#include "lua50/lua.h"
#include "lua50/lualib.h"
#include "lua50/lauxlib.h"

/*
   Ceci n'est pas de la programmation Lua à proprement parler, mais son
   Interaction de l'interpréteur Lua et un exécutable C.

   Cette pratique permet d'intégrer (embedding) l'interpréteur, exactement
   comme de grosses applications le font (Far Cry, etc...) lorsqu'elles
   ont besoin d'interfacer du code utilisateur par des scripts triviaux.
*/

int main(int argc, char* argv[])
{
  lua_State* L = lua_open();
  luaopen_base(L);
  luaopen_io(L);

  lua_dofile(L,"1.lua");

  lua_close(L);
  return 0;
}

/*
Compiler/Exécuter avec
  $ gcc -Wall -s -o 1 1.c -llua50 -llualib50 
  $ ./1
  Hello, World!

 Ce qui se passe, c'est que l'interpréteur Lua est intégré dans l' exécutable,
 en étant linké à la compilation.

 Lua permet la précompilation de code Lua en bytecode:
 $ luac -s -o hello.bytecode 1.lua
 Ce bytecode est égalemetn interprétable par "notre" exécutable:
 $ ./1 hello.bytecode
  Hello, World!
 112 octets le fichier. C'est mieux que le meilleur des assembleurs.

*/
